#ifndef GWt_elementLigneFaisceau_SEEN
#define GWt_elementLigneFaisceau_SEEN

#include "GWt_dialog.h"
#include "GWt_pspaApplication.h"
#include "abstractElement.h"
#include "GWt_abstractElement.h"
#include "GWt_dropZoneLigneFaisceau.h"

#include <Wt/WContainerWidget>

using namespace Wt;


class GWt_elementLigneFaisceau : public WContainerWidget
{
 public : 
  /**
     dropZone element
     a drop zone is the basic element for a widget in the ligne faisceau drop zone area
     it should be like this :

     +----------+--------+---------+
     |   (--->) |  ELEM  | (-----) |
     +----------+--------+---------+
     |             NAME            |
     +----------+--------+---------+
     ELEM : Element representation, draggable object
     (----) and (---->) : Droppable zone, contain arrows or line if this element is connected to another
     NAME : editable element name

    At first time, the ELEM element is replace by a message.

    @param pspa : application name
    @param linkImage : true/false if the drop zone have to display the link image
    @param showInsertMessage : true/false if it has to display the insertMessage at first step
   */

  GWt_elementLigneFaisceau();
  GWt_elementLigneFaisceau(abstractElement*);

  ~GWt_elementLigneFaisceau();
  void addElement(GWt_abstractElement* elem);

  inline WText* getElementName() {
    return elementName_;
  }

  inline WText* getElementIcon() {
    return elementName_;
  }

    void setElementName(std::string label);

private:

  void onClick(GWt_abstractElement*);
  void removeDone(GWt_abstractElement*); 
  std::string getElementNumberInBeamLine(nomdElements el);
  void removeOtherDropZone(GWt_elementLigneFaisceau*);
  void initialize_ligneFaisceau(abstractElement*);
  PspaApplication* pspa_;
  GWt_dialog* messageDropZone_;
  WText* firstTimeInsertMessage_;

  GWt_dropZoneLigneFaisceau* arrowImage_;
  WContainerWidget* dragElementZone_;
  GWt_dropZoneLigneFaisceau* lineImage_;
  WText* elementName_;

  GWt_abstractElement* abstractElement_;
};
#endif
